<?php
# $Id: map.php 4336 2009-07-10 15:28:50Z christoph $
# http://www.mapbender.org/index.php/Map.php
# Copyright (C) 2002 CCGIS
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

require_once(dirname(__FILE__)."/../php/mb_validateSession.php");

// see http://trac.osgeo.org/mapbender/ticket/79
ini_set('session.bug_compat_42',0); 
ini_set('session.bug_compat_warn',0);

/*
// may be added at a later stage
$gui_changed=0;
$new_wmc=0;

if (!$_REQUEST["layer_preview"] && isset($_SESSION["mb_user_gui"]) && $_SESSION["mb_user_gui"] != $_REQUEST["gui_id"]) {
	$gui_changed=1;
}

if (!isset($_SESSION['mb_wmc']) || ($gui_changed==1) ||	($_REQUEST['layer_preview'] && $_REQUEST['portal_services'])) {
	$new_wmc=1;
}

if (isset($_REQUEST['layer_preview']) && $_REQUEST['layer_preview'] != 0) {
	$_SESSION['layer_preview'] = $_REQUEST['portal_services'];
}
else {
	$_SESSION['layer_preview'] = 0;
}
*/
$_SESSION["mb_user_gui"] = $gui_id;

ob_start();
header('Content-type: application/x-javascript');

//
// Define global variables (TODO: move to mapbender object later on)
//
echo "var mb_nr = '".session_id()."';";
echo "var mb_session_name = '".session_name()."';";
echo "var mb_myLogin = '".$_SESSION["mb_login"]."';";
echo "var mb_styleID = '".md5($_SESSION["mb_user_name"])."';";
echo "var mb_myBBOX = '".$_SESSION["mb_myBBOX"]."';";
echo "var Mapbender = {};";
echo "Mapbender.locale = '" . $_SESSION["mb_locale"] . "';";
echo "Mapbender.languageId = '" . $_SESSION["mb_lang"] . "';";
echo "Mapbender.versionNumber = '" . MB_VERSION_NUMBER . "';";
echo "Mapbender.versionAppendix = '" . MB_VERSION_APPENDIX . "';";
echo "Mapbender.releaseDate = new Date(".date("Y",MB_RELEASE_DATE).",".date("n",MB_RELEASE_DATE).",".date("j",MB_RELEASE_DATE).");";
echo "Mapbender.zoomMousewheel = " . ZOOM_MOUSEWHEEL . ";";
echo "var owsproxy = '".OWSPROXY."';";
echo "var global_mb_log_js = '".LOG_JS."';";
echo "var global_mb_log_level = '".LOG_LEVEL."';";
echo "var global_log_levels = '".LOG_LEVEL_LIST."';";
echo "var mb_feature_count = ".MB_FEATURE_COUNT.";";
echo "var mb_resolution = ".MB_RESOLUTION.";";
echo "var mb_security_proxy = '" . MB_SECURITY_PROXY . "';";

//
// Load external JavaScript libraries
//
$extPath = dirname(__FILE__) . "/../extensions/";
$extFileArray = array(  "jquery-1.2.6.min.js", 
						"jqjson.js", 
						"jquery.mousewheel.min.js",
						"jquery.form.js");

for ($i = 0; $i < count($extFileArray); $i++) {
	$currentFile = $extPath . $extFileArray[$i];
	if (file_exists($currentFile)) {
		require_once($currentFile);
	}
	else {
		$e = new mb_exception("Extension not found: " . $currentFile);
		echo "var e = new Mb_exception('Library not found: " . $currentFile . "');";
		die;
	}
}

//
// Load internal JavaScript libraries
//
$libPath = dirname(__FILE__) . "/../../lib/";
$libFileArray = array(  "exception.js", 
						"ajax.js", 
						"basic.js",
						"div.js",
						"list.js",
						"point.js",
						"style.js",
						"button.js");

for ($i = 0; $i < count($libFileArray); $i++) {
	$currentFile = $libPath . $libFileArray[$i];
	if (file_exists($currentFile)) {
		require_once($currentFile);
		echo "\n";
	}
	else {
		$e = new mb_exception("Library not found: " . $currentFile);
		echo "var e = new Mb_exception('Library not found: " . $currentFile . "');";
		die;
	}
}

//
// Load JavaScript modules of GUI elements
//
$sql = "SELECT DISTINCT e_mb_mod FROM gui_element WHERE e_public = 1 AND fkey_gui_id = $1";
$v = array($gui_id);
$t = array('s');
$res = db_prep_query($sql, $v, $t);
while($row = db_fetch_array($res)){
	if($row["e_mb_mod"] != ""){
		$moduleArray = explode(",", $row["e_mb_mod"]);
		for ($i = 0; $i < count($moduleArray); $i++) {
			$currentFile = dirname(__FILE__) . "/../javascripts/" . trim($moduleArray[$i]);
			if (file_exists($currentFile)) {
				$e = new mb_notice("LOADING module : " . $currentFile);
				require_once($currentFile);
				echo "\n";
			}
			else {
				$e = new mb_exception("Javascript module not found: " . $currentFile);
				echo "var e = new Mb_exception('Javascript module not found: " . $currentFile . "');";
			}
		}
	}
}

//
// Load JavaScript files of GUI elements
//

$modulesNotRelyingOnGlobalsArray = explode(",", MODULES_NOT_RELYING_ON_GLOBALS);

echo "\nMapbender.Modules = {};\n";
$mb_sql = "SELECT DISTINCT e_js_file, e_id, e_src, e_target, e_pos, " .
		"e_url, e_left, e_top, e_width, e_height, e_requires FROM gui_element WHERE e_public = 1 AND " .
		"fkey_gui_id = $1 ORDER BY e_pos";
$mb_v = array($gui_id);
$mb_t = array("s");
$mb_res = db_prep_query($mb_sql, $mb_v, $mb_t);
while($row_js = db_fetch_array($mb_res)){
	if($row_js["e_js_file"] != ""){
		$jsArray = explode(",", $row_js["e_js_file"]);
		for ($i = 0; $i < count($jsArray); $i++) {
			$e_id = $row_js["e_id"];
			$e_src = $row_js["e_src"];
			$e_require = $row_js["e_requires"];
			$e_target = explode(",",$row_js["e_target"]);
			$e_width = intval($row_js["e_width"]);
			$e_height = intval($row_js["e_height"]);
			$currentFile = trim($jsArray[$i]);
			if (file_exists($currentFile)) {
				echo "Mapbender.Modules." . $e_id . " = {\n";
				echo "id:'".$row_js["e_id"]."',";
				echo "url:'".$row_js["e_url"]."',";
				echo "top:'".$row_js["e_top"]."',";
				echo "left:'".$row_js["e_left"]."',";
				echo "width:'".$row_js["e_width"]."',";
				echo "height:'".$row_js["e_height"]."'";
				if (in_array($e_id, $modulesNotRelyingOnGlobalsArray)) {
					echo ",\ninit : function () {\n";
					require($currentFile);
					echo "}\n";
					echo "};\n";
				}
				else {
					echo "};\n";
					require($currentFile);
				}
			}
			else {
				$e = new mb_exception("Javascript not found: " . $currentFile);
				echo "var e = new Mb_exception('Javascript not found: " . $currentFile . "');";
				die;
			}
		}
	}
}
?>
eventBeforeInit.register(function () {
	for (var module in Mapbender.Modules) {
		var initFunction = Mapbender.Modules[module].init;
		if (typeof(initFunction) == "function") {
			Mapbender.Modules[module].init();
		}
	}
});
