<?php
# $Id: globalSettings.php 6890 2010-09-03 14:53:02Z christoph $
# Copyright (C) 2002 CCGIS 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

ob_start();

//
// constants
//
require_once(dirname(__FILE__)."/../core/system.php");

//
// initiates the session-handling
//
if (defined("SESSION_NAME") && is_string(SESSION_NAME)) {
//	session_name(SESSION_NAME);
}
session_start();
//
// Add FirePHP for debugging only, supply a global $firephp
//
if (defined("LOG_PHP_WITH_FIREPHP") && LOG_PHP_WITH_FIREPHP === "on") {
	require_once(dirname(__FILE__)."/../http/extensions/FirePHP-0.3/FirePHP.class.php");
	
	$firephp = FirePHP::getInstance(true);
}

//
// Basic Mapbender classes, for session handling etc.
//
require_once(dirname(__FILE__)."/../lib/class_Mapbender.php");

//
// define LC_MESSAGES if unknown (for Windows platforms)
// 
if (!defined("LC_MESSAGES")) define("LC_MESSAGES", LC_CTYPE);

//
// All data Mapbender handles internally are UTF-8
//
mb_internal_encoding("UTF-8");

//
// if magic quotes is on, automatically strip slashes
// (non-recursive due to possible security hazard)
//
if (get_magic_quotes_gpc()) {
	$in = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
	
	while (list($k, $v) = each($in)) {
		foreach ($v as $key => $val) {
			if (!is_array($val)) {
				$in[$k][$key] = stripslashes($val);
				continue;
			}
			$in[]= &$in[$k][$key];
		}
	}

	unset($in);
}


//
// configuration file
//
require_once(dirname(__FILE__)."/../conf/mapbender.conf");


//
// until we have decided how to implement a public user,
// use this constant. In Geoportal.rlp.de it was used as ANONYMOUS_USER
// 
if (!defined("PUBLIC_USER")) define("PUBLIC_USER", "");

if (!defined("LOAD_JQUERY_FROM_GOOGLE")) define("LOAD_JQUERY_FROM_GOOGLE", false);

//
// database wrapper
//
if(SYS_DBTYPE=="mysql") {
	require_once(dirname(__FILE__) . "/../lib/database-mysql.php"); 
}
else {
	require_once(dirname(__FILE__) . "/../lib/database-pgsql.php"); 
}

//
// class for error handling
//
DEFINE("LOG_DIR", dirname(__FILE__) . "/../log/");		
require_once(dirname(__FILE__)."/../http/classes/class_mb_exception.php");

//
// I18n wrapper function, gettext
//
require_once(dirname(__FILE__) . "/../core/i18n.php");
require_once(dirname(__FILE__) . "/../http/classes/class_locale.php");
$localeObj = new Mb_locale(Mapbender::session()->get("mb_lang"));


//
// establish database connection
//
$con = db_connect($DBSERVER, $OWNER, $PW);
db_select_db(DB, $con);

//
// Do not display PHP errors
//
ini_set("display_errors", "0");

//
// AJAX wrapper
//
require_once(dirname(__FILE__)."/../lib/ajax.php");

//
// get real ip address, can be improved, see
// http://roshanbh.com.np/2007/12/getting-real-ip-address-in-php.html
//
function getRealIpAddr() {
    if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
    {
      $ip=$_SERVER['HTTP_CLIENT_IP'];
    }
    elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
    {
      $ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
    }
    else
    {
      $ip=$_SERVER['REMOTE_ADDR'];
    }
    return $ip;
}

?>
