<?php
//
// Load WMS via WMC
// 
require_once dirname(__FILE__)."/../php/mb_validateSession.php";
require_once dirname(__FILE__)."/../classes/class_wmc.php";
require_once dirname(__FILE__)."/../classes/class_administration.php";
require_once dirname(__FILE__)."/../../lib/class_GetApi.php";

$wmc = new wmc();

//check if session contains a wmc, otherwise create a new wmc from application
if (!Mapbender::session()->get("mb_wmc")) {
	$e = new mb_notice("wmc not set, generating from app: " . Mapbender::session()->get("mb_user_gui"));
	$wmc->createFromApplication(Mapbender::session()->get("mb_user_gui"));
}
else {
	if (!$wmc->createFromXml(Mapbender::session()->get("mb_wmc"))) {
		$e = new mb_notice("error creating initial WMC from session.");
	}
}

function getConfiguration ($key) {
	//check if key param can be found in SESSION, 
	// otherwise take it from GET
	if (Mapbender::session()->exists($key)) {
		return Mapbender::session()->get($key);
	}
	return $_GET[$key];
}

$options = array();
if (Mapbender::session()->exists("addwms_showWMS")) {
	$options["show"] = intval(Mapbender::session()->get("addwms_showWMS"));
}
if (Mapbender::session()->exists("addwms_zoomToExtent")) {
	$options["zoom"] = !!Mapbender::session()->get("addwms_zoomToExtent");
}

$getParams = array(
	"WMS" => getConfiguration("WMS"),
	"LAYER" => getConfiguration("LAYER"),
	"FEATURETYPE" => getConfiguration("FEATURETYPE")
);
$getApi = new GetApi($getParams);

if ($getParams['WMS']) {
	// WMS param given as array
	if (is_array($getParams['WMS'])) {
		$inputWmsArray = $getParams['WMS'];
	}
	// WMS param given as comma separated list
	else {
		$inputWmsArray = split(",",$getParams['WMS']); 
	}
	
	$wmsArray = array();
	$singleAssocArray = array();
	$multipleAssocArray = array();
	
	foreach ($inputWmsArray as $key=>$val) {
		if (is_array($val)) {
			foreach ($val as $attr=>$value) {
				$multipleAssocArray[$attr] = $value;
			}
			//get WMS by ID with settings of given application
			if (array_key_exists('application', $multipleAssocArray) && 
				array_key_exists('id', $multipleAssocArray)) {
				$currentWms = new wms();	
				$currentWms->createObjFromDB($multipleAssocArray['application'], $multipleAssocArray['id']);
			}
			//get WMS by URL
			elseif (array_key_exists('url', $multipleAssocArray)) {
				$currentWms = new wms();
				$currentWms->createObjFromXML($multipleAssocArray['url']);
			}
			else {
				continue;
			}
			array_push($wmsArray, $currentWms);
			
			if($multipleAssocArray['visible'] && $multipleAssocArray['visible'] != "") {
				$options['visible'] = $multipleAssocArray['visible'] === "true" ? true : false;
			}
			if($multipleAssocArray['zoom'] && $multipleAssocArray['zoom'] != "") {
				$options['zoom'] = $multipleAssocArray['zoom'] === "true" ? true : false;
			}
			
			$wmc->mergeWmsArray($wmsArray, $options);
			$wmsArray = array();
			$multipleAssocArray = array();
		}
		else {
			$currentWms = new wms();
			if(is_numeric($key)) {
				//get WMS by URL
				if (is_string($val)) {
					$currentWms->createObjFromXML($val);
				}
				//get WMS by ID
				if (is_numeric($val)) {
					$currentWms->createObjFromDBNoGui($val);
				}
				array_push($wmsArray, $currentWms);
				$wmc->mergeWmsArray($wmsArray);
				$wmsArray = array();
			} 
			else {
				$singleAssocArray[$key] = $val;
			}
		}
	}
	
	//get WMS by ID with settings of given application
	if (array_key_exists('application', $singleAssocArray) && 
		array_key_exists('id', $singleAssocArray)) {
		$currentWms = new wms();	
		$currentWms->createObjFromDB($singleAssocArray['application'], $singleAssocArray['id']);
		array_push($wmsArray, $currentWms);
		if($singleAssocArray['visible'] && $singleAssocArray['visible'] != "") {
			$options['visible'] = $singleAssocArray['visible'] === "true" ? true : false;
		}
		
		if($singleAssocArray['zoom'] && $singleAssocArray['zoom'] != "") {
			$options['zoom'] = $singleAssocArray['zoom'] === "true" ? true : false;
		}
		$wmc->mergeWmsArray($wmsArray, $options);
		$wmsArray = array();
		$singleAssocArray = array();
	}
	//get WMS by URL
	elseif (array_key_exists('url', $singleAssocArray)) {
		$currentWms = new wms();
		$currentWms->createObjFromXML($singleAssocArray['url']);
		array_push($wmsArray, $currentWms);
		if($singleAssocArray['visible'] && $singleAssocArray['visible'] != "") {
			$options['visible'] = $singleAssocArray['visible'] === "true" ? true : false;
		}
		if($singleAssocArray['zoom'] && $singleAssocArray['zoom'] != "") {
			$options['zoom'] = $singleAssocArray['zoom'] === "true" ? true : false;
		}
		$wmc->mergeWmsArray($wmsArray, $options);
		$wmsArray = array();
		$singleAssocArray = array();
	}
}

$inputLayerArray = $getApi->getLayers();
if ($inputLayerArray) {
	foreach ($inputLayerArray as $input) {
		// just make it work for a single layer id
		$wmsFactory = new UniversalWmsFactory();
		$wms = $wmsFactory->createLayerFromDb($input["id"]);
		$options = array();
		if ($input["visible"]) {
			// this is a hack for the time being:
			// make WMS visible if it has less than 100000 layers
			$options["show"] = 100000;
		}
		$wmc->mergeWmsArray(array($wms), $options);
	}
}

$inputFeaturetypeArray = $getApi->getFeaturetypes();
if ($inputFeaturetypeArray) {
	$wfsConfIds = array();	
	foreach ($inputFeaturetypeArray as $input) {
		array_push($wfsConfIds, $input["id"]);
	}
	
	$wmc->generalExtensionArray['WFSCONFIDSTRING'] = implode(",", array_merge(
		$wmc->generalExtensionArray['WFSCONFIDSTRING'] ? 
			explode(",", $wmc->generalExtensionArray['WFSCONFIDSTRING']) : array(),
		$wfsConfIds
	));
}

//workaround to have a fully merged WMC for loading

$xml = $wmc->toXml();

$wmc = new wmc();
$wmc->createFromXml($xml);

$output = $wmc->wmsToJavaScript();

//workaround for zoom to WMS
$extent = $wmc->mainMap->getExtent();
Mapbender::session()->set("mb_myBBOX", $extent->min->x . "," . $extent->min->y . "," . $extent->max->x . "," . $extent->max->y);

$outputString = "";
for ($i = 0; $i < count($output); $i++) {
	$outputString .= administration::convertOutgoingString($output[$i]);
}

$wmcFeaturetypeJson = $wmc->featuretypeConfToJavaScript();
$wmcFeaturetypeStr = <<<JS
	Mapbender.events.afterInit.register(function () {
		$('#body').trigger('addFeaturetypeConfs', [
			{featuretypeConfObj : $wmcFeaturetypeJson}
		]);
	});
JS;

$outputString .= $wmcFeaturetypeStr;

echo $outputString;


Mapbender::session()->delete("addwms_showWMS");
Mapbender::session()->delete("addwms_zoomToExtent");
unset($output);
unset($wmc);
?>
