<?php
/*
 * License:
 * Copyright (c) 2009, Open Source Geospatial Foundation
 * This program is dual licensed under the GNU General Public License 
 * and Simplified BSD license.  
 * http://svn.osgeo.org/mapbender/trunk/mapbender/license/license.txt
 */

require_once(dirname(__FILE__)."/../php/mb_validateSession.php");
require_once(dirname(__FILE__)."/../classes/class_administration.php");
require_once(dirname(__FILE__)."/../classes/class_wmc.php");
require_once(dirname(__FILE__)."/../classes/class_json.php");

$ajaxResponse = new AjaxResponse($_POST);
if($ajaxResponse->getMethod() != "saveWMC") {
	$ajaxResponse->setSuccess(false);
	$ajaxResponse->setMessage("method invalid");
	$ajaxResponse->send();
	exit;
}

$json = new Mapbender_JSON(); 

// get data from POST and SESSION
$userId = Mapbender::session()->get("mb_user_id");
$mapObject = $ajaxResponse->getParameter('mapObject'); 
$saveInSession = $ajaxResponse->getParameter('saveInSession'); 
$extensionData = $json->decode($ajaxResponse->getParameter('extensionData'));
$attributes =  $ajaxResponse->getParameter('attributes');
$overwrite = $ajaxResponse->getParameter('overwrite');
$overwrite = $overwrite == "1" ? true : false;

$mapObject = $json->decode($mapObject);

// create WMC object
$wmc = new wmc();
if($overwrite) {
	$wmc->createFromJs($mapObject, $attributes->title, $extensionData, $attributes->wmc_id);
}
else {
	$wmc->createFromJs($mapObject, $attributes->title, $extensionData);
}

if ($saveInSession === 1) {
	// store XML in session
	Mapbender::session()->set("mb_wmc",$wmc->xml);
	Mapbender::session()->set("epsg",$mapObject->epsg);
	Mapbender::session()->set("previous_gui", Mapbender::session()->get("mb_user_gui"));
	
	$e = new mb_notice("mod_insertWMCIntoDB: save WMC in session succeeded.");
	$ajaxResponse->setSuccess(true);
	$ajaxResponse->setResult(_mb("saved wmc document to session"));
}
else {
	// insert WMC into database
	
	if(isset($attributes->title)) {
		$attributes->title = trim($attributes->title);
		if($attributes->title == "") {
		  $ajaxResponse->setSuccess(false);
		  $ajaxResponse->setMessage(_mb("WMC document must have a title."));
		  $ajaxResponse->send();
		  exit;
		}
	}
	else{
		$ajaxResponse->setSuccess(false);
		$ajaxResponse->setMessage(_mb("WMC document must have a title."));
		$ajaxResponse->send();
		exit;
	}
	foreach($mapObject as $map)	{
		if (isset($mapObject->isOverview) && $mapObject->isOverview == "1") { continue; }
		$wmc->wmc_extent  = $map->extent;
		$wmc->wmc_srs	  = $map->epsg;
	}
	// make a keyword array here
	$wmc->keyword = explode(" ",$attributes->keywords);
	$wmc->wmc_abstract = $attributes->abstract;
	$inspireCat = $attributes->inspirecat;
	foreach($inspireCat as $cat => $val) {
		$parts = explode("_",$cat);
		$wmc->inspireCats[] =  $parts[1];
	}

	$result = $wmc->insert($overwrite);
	$ajaxResponse->setSuccess(true);
	$ajaxResponse->setResult($result);
	$ajaxResponse->setMessage(_mb("WMC %s has been saved.", "'" . $attributes->title . "'"));
}

$ajaxResponse->send();
?>