<?php
	require_once dirname(__FILE__) . "/../../core/globalSettings.php";
?>

<fieldset>
	<input name="wms_id" id="wms_id" type="hidden"/>

	<legend><?php echo _mb("Service Level Metadata");?>: <img class="help-dialog" title="<?php echo _mb("Help");?>" help="{text:'<?php echo _mb("Possibility to adapt and add informations in the separate WMS-Layer Metadata. The modified Metadata is stored in the database of the GeoPortal.rlp, outwardly these metadata overwrite the original Service-Metadata.");?>'}" src="../img/questionmark.png"></img></legend>
	<p>
		<label for="wms_title"><?php echo _mb("Show original Service Metadata from last update");?></label>
		<img class="original-metadata-wms" src="../img/book.png"></img>
		<img class="help-dialog" title="<?php echo _mb("Help");?>" help="{text:'<?php echo _mb("The original WMS-Metadata from the last update could be recovered or updated, so that the original Service-Metadata will be shown outward again.");?>'}" src="../img/questionmark.png"></img>
	</p>
	<p>
		<label for="wms_title"><?php echo _mb("WMS Title (OWS)");?>:</label>
		<input name="wms_title" id="wms_title" class="required"/>
		<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
    	<label for="wms_abstract"><?php echo _mb("WMS Abstract (OWS)");?>:</label>
    	<input name="wms_abstract" id="wms_abstract"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="wms_keywords"><?php echo _mb("WMS Keywords (OWS)");?>:</label>
    	<input readonly="readonly" name="wms_keywords" id="wms_keywords"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="fees"><?php echo _mb("WMS Fees (OWS)");?>:</label>
    	<input name="fees" id="fees"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="accessconstraints"><?php echo _mb("WMS AccessConstraints (OWS)");?>:</label>
		<input name="accessconstraints" id="accessconstraints"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
<?php
	$sql = "SELECT termsofuse_id, name FROM termsofuse";
	$res = db_query($sql);
	$termsofuse = array();
	while ($row = db_fetch_assoc($res)) {
		$termsofuse[$row["termsofuse_id"]] = $row["name"];
	}
?>
	<p>
		<label for="wms_termsofuse"><?php echo _mb("WMS Predefined Licence (Registry)");?>:</label>
    	<select name="wms_termsofuse" id="wms_termsofuse">
			<option>...</option>
<?php
	foreach ($termsofuse as $key => $value) {
		echo "<option value='" . $key . "'>" . htmlentities($value, ENT_QUOTES, CHARSET) . "</option>";
	}
?>
		</select>
    	<img class="help-dialog" title="<?php echo _mb("Help");?>" help="{text:'<?php echo _mb("Auswahl von vordefinierten Lizenzen hinsichtlich Gebühren und Zugriffsbeschränkungen.");?>'}" src="../img/questionmark.png"></img>
	</p>
</fieldset>
<fieldset>
	<legend><?php echo _mb("WMS Provider Section (OWS)");?></legend>
	<p>
		<label for="contactperson"><?php echo _mb("Contact Individual Name (OWS)");?>:</label>
    	<input name="contactperson" id="contactperson"/>
	</p>
	<p>
		<label for="contactposition"><?php echo _mb("Contact Position Name (OWS)");?>:</label>
    	<input name="contactposition" id="contactposition"/>
	</p>
	<p>
		<label for="contactvoicetelephone"><?php echo _mb("Contact Phone Voice (OWS)");?>:</label>
    	<input name="contactvoicetelephone" id="contactvoicetelephone"/>
	</p>
	<p>
		<label for="contactfacsimiletelephone"><?php echo _mb("Contact Phone Fax (OWS)");?>:</label>
    	<input name="contactfacsimiletelephone" id="contactfacsimiletelephone"/>
	</p>
	<p>
		<label for="contactorganization"><?php echo _mb("Contact Organisation (WMS)");?>:</label>
    	<input name="contactorganization" id="contactorganization"/>
    	<img  class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="address"><?php echo _mb("Contact Address (WMS)");?>:</label>
    	<input name="address" id="address"/>
	</p>
	<p>
		<label for="city"><?php echo _mb("Contact City (WMS)");?>:</label>
     	<input name="city" id="city"/>
	</p>
	<p>
	  	<label for="stateorprovince"><?php echo _mb("Contact State or Province (WMS) - ISO 3166-II");?>:</label>
      	<input name="stateorprovince" id="stateorprovince"/>
	</p>
	<p>
	  	<label for="postcode"><?php echo _mb("Contact Post Code (WMS)");?>:</label>
      	<input name="postcode" id="postcode"/>
	</p>
	<p>
	  	<label for="country"><?php echo _mb("Contact Post Country (WMS) - ISO 3166");?>:</label>
      	<input name="country" id="country"/>
	</p>
	<p>
	  	<label for="contactelectronicmailaddress"><?php echo _mb("Contact Electronic Mail Address (WMS)");?>:</label>
      	<input name="contactelectronicmailaddress" id="contactelectronicmailaddress" class="required email"/>
     	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
	  	<label for="wms_timestamp_create"><?php echo _mb("Date of first registration (Registry)");?>:</label>
      	<input readonly="readonly" name="wms_timestamp_create" id="wms_timestamp_create"/>
      	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
	  	<label for="wms_timestamp"><?php echo _mb("Date of last revision (Registry)");?>:</label>
      	<td><input readonly="readonly" name="wms_timestamp" id="wms_timestamp"/>
      	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
</fieldset>
