<?php
require_once(dirname(__FILE__)."/../../core/globalSettings.php");
require_once(dirname(__FILE__)."/../../http/classes/class_connector.php");
require_once(dirname(__FILE__)."/../../http/classes/class_administration.php");

//define("LAYER_PREVIEW_BASE","../tmp/layerpreviews/");
define("LAYER_PREVIEW_BASE","../tmp/");

$layerPreviewMapFileName = LAYER_PREVIEW_BASE . sha1(uniqid(rand()));
$layerPreviewLegendFileName = LAYER_PREVIEW_BASE . sha1(uniqid(rand()));

$ajaxResponse  = new AjaxResponse($_REQUEST);
$mapurl =  $ajaxResponse->getParameter("mapurl");
$layerName =  $ajaxResponse->getParameter("layerName");
$legendUrl =  $ajaxResponse->getParameter("legendUrl");
$wmsId =  $ajaxResponse->getParameter("wmsId");

if(!$mapurl){
	$ajaxResponse->setSuccess(false);
	$ajaxResponse->setMessage('mapURL not set');
	$ajaxResponse->send();
}

/*
if(!$legendurl){
	$ajaxResponse->setSuccess(false);
	$ajaxResponse->setMessage('legendURL not set');
	$ajaxResponse->send();
}
*/
if (!$wmsId) {
	$ajaxResponse->setSuccess(false);
	$ajaxResponse->setMessage('wmsId not set');
	$ajaxResponse->send();
}
if (!$layerName) {
	$ajaxResponse->setSuccess(false);
	$ajaxResponse->setMessage('layerName not set');
	$ajaxResponse->send();
}

switch ($ajaxResponse->getMethod()) {
	case "saveLayerPreview":
		$con = new connector();
		$admin = new administration();
		$mapImage = $con->load($mapurl);
		if (!$mapImage) {
			$ajaxResponse->setSuccess(false);
			$ajaxResponse->setMessage('Could not save preview: Unable to load map image.');
			$ajaxResponse->send();			
		}
		$admin->saveFile($layerPreviewMapFileName,$mapImage);

		if ($legendUrl) {
			$legendImage = $con->load($legendUrl);
			if (!$legendImage) {
				$ajaxResponse->setSuccess(false);
				$ajaxResponse->setMessage('Could not save preview: Unable to load map image.');
				$ajaxResponse->send();			
			}
			$admin->saveFile($layerPreviewLegendFileName,$legendImage);
		}
		else {
			$legendUrl = null;
		}

		$updateSQL = <<<SQL

UPDATE layer_preview SET 
	layer_map_preview_filename = $1,
	layer_legend_preview_filename = $2
WHERE layer_preview.fkey_layer_id IN (
	SELECT layer_id FROM layer 
	WHERE fkey_wms_id = $wmsId AND layer_name = $3
)
SQL;
		$insertSQL = <<<SQL
		
INSERT INTO layer_preview (
	fkey_layer_id, 
	layer_map_preview_filename, 
	layer_legend_preview_filename
) 
	SELECT layer_id, $1, $2 	
	FROM layer 
	WHERE fkey_wms_id = $wmsId AND layer_name = $3 
		AND NOT  EXISTS (
			SELECT fkey_layer_id FROM layer JOIN layer_preview 
			ON fkey_layer_id = layer_id 
			WHERE fkey_wms_id = $wmsId AND layer_name = $4
		)
SQL;
		$updateResult = db_prep_query(
			$updateSQL,
			array($layerPreviewMapFileName, $layerPreviewLegendFileName, $layerName), 
			array("s", "s", "s")
		);
		$insertResult = db_prep_query(
			$insertSQL,
			array($layerPreviewMapFileName, $layerPreviewLegendFileName, $layerName, $layerName), 
			array("s", "s", "s", "s")
		);
		if (!$insertResult && !$updateResult) {
			new mb_exception("could not insert/update layerPreview into db");
			$ajaxResponse->setSuccess(false);
			$ajaxResponse->setMessage("could not insert/Update layerPreview into db: ". pg_last_error());
		}
		break;

	default:
		$ajaxResponse->setSuccess(false);
		$ajaxResponse->setMessage("invalid method");
}
$ajaxResponse->send();
?>