<?php
	require_once dirname(__FILE__) . "/../../core/globalSettings.php";
?>

<fieldset>
	<input name="wfs_id" id="wfs_id" type="hidden"/>

	<legend><?php echo _mb("Service Level Metadata");?>: <img class="help-dialog" title="<?php echo _mb("Help");?>" help="{text:'<?php echo _mb("Possibility to adapt and add informations in the separate WFS-Featuretype Metadata. The modified Metadata is stored in the database of the GeoPortal.rlp, outwardly these metadata overwrite the original Service-Metadata.");?>'}" src="../img/questionmark.png"></img></legend>
	<p>
		<label for="wfs_title"><?php echo _mb("Show original Service Metadata from last update");?></label>
		<img class="original-metadata-wfs" src="../img/book.png"></img>
		<img class="help-dialog" title="<?php echo _mb("Help");?>" help="{text:'<?php echo _mb("The original WFS-Metadata from the last update could be recovered or updated, so that the original Service-Metadata will be shown outward again.");?>'}" src="../img/questionmark.png"></img>
	</p>
	<p>
		<label for="title"><?php echo _mb("WFS Title (OWS)");?>:</label>
		<input name="title" id="title" class="required"/>
		<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
    	<label for="summary"><?php echo _mb("WFS Abstract (OWS)");?>:</label>
    	<input name="summary" id="summary"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="wfs_keywords"><?php echo _mb("WFS Keywords (OWS)");?>:</label>
    	<input readonly="readonly" name="wfs_keywords" id="wfs_keywords"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="fees"><?php echo _mb("WFS Fees (OWS)");?>:</label>
    	<input name="fees" id="fees"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="accessconstraints"><?php echo _mb("WFS AccessConstraints (OWS)");?>:</label>
		<input name="accessconstraints" id="accessconstraints"/>
    	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
<?php
	$sql = "SELECT termsofuse_id, name FROM termsofuse";
	$res = db_query($sql);
	$termsofuse = array();
	while ($row = db_fetch_assoc($res)) {
		$termsofuse[$row["termsofuse_id"]] = $row["name"];
	}
?>
	<p>
		<label for="wfs_termsofuse"><?php echo _mb("WFS Predefined Licence (Registry)");?>:</label>
    	<select name="wfs_termsofuse" id="wfs_termsofuse">
			<option>...</option>
<?php
	foreach ($termsofuse as $key => $value) {
		echo "<option value='" . $key . "'>" . htmlentities($value, ENT_QUOTES, CHARSET) . "</option>";
	}
?>
		</select>
    	<img class="help-dialog" title="<?php echo _mb("Help");?>" help="{text:'<?php echo _mb("Auswahl von vordefinierten Lizenzen hinsichtlich Gebühren und Zugriffsbeschränkungen.");?>'}" src="../img/questionmark.png"></img>
	</p>
</fieldset>
<fieldset>
	<legend><?php echo _mb("WFS Provider Section (OWS)");?></legend>
	<p>
		<label for="individualName"><?php echo _mb("Contact Individual Name (OWS)");?>:</label>
    	<input name="individualName" id="individualName"/>
	</p>
	<p>
		<label for="positionName"><?php echo _mb("Contact Position Name (OWS)");?>:</label>
    	<input name="positionName" id="positionName"/>
	</p>
	<p>
		<label for="voice"><?php echo _mb("Contact Phone Voice (OWS)");?>:</label>
    	<input name="voice" id="voice"/>
	</p>
	<p>
		<label for="facsimile"><?php echo _mb("Contact Phone Fax (OWS)");?>:</label>
    	<input name="facsimile" id="facsimile"/>
	</p>
	<p>
		<label for="providerName"><?php echo _mb("Contact Organisation (WFS)");?>:</label>
    	<input name="providerName" id="providerName"/>
    	<img  class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
		<label for="deliveryPoint"><?php echo _mb("Contact Address (WFS)");?>:</label>
    	<input name="deliveryPoint" id="deliveryPoint"/>
	</p>
	<p>
		<label for="city"><?php echo _mb("Contact City (WFS)");?>:</label>
     	<input name="city" id="city"/>
	</p>
	<p>
	  	<label for="administrativeArea"><?php echo _mb("Contact State or Province (WFS) - ISO 3166-II");?>:</label>
      	<input name="administrativeArea" id="administrativeArea"/>
	</p>
	<p>
	  	<label for="postalCode"><?php echo _mb("Contact Post Code (WFS)");?>:</label>
      	<input name="postalCode" id="postalCode"/>
	</p>
	<p>
	  	<label for="country"><?php echo _mb("Contact Post Country (WFS) - ISO 3166");?>:</label>
      	<input name="country" id="country"/>
	</p>
	<p>
	  	<label for="electronicMailAddress"><?php echo _mb("Contact Electronic Mail Address (WFS)");?>:</label>
      	<input name="electronicMailAddress" id="electronicMailAddress" class="required email"/>
     	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
	  	<label for="wfs_timestamp_create"><?php echo _mb("Date of first registration (Registry)");?>:</label>
      	<input readonly="readonly" name="wfs_timestamp_create" id="wfs_timestamp_create"/>
      	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
	<p>
	  	<label for="wfs_timestamp"><?php echo _mb("Date of last revision (Registry)");?>:</label>
      	<td><input readonly="readonly" name="wfs_timestamp" id="wfs_timestamp"/>
      	<img class="metadata_img" title="<?php echo _mb("Inspire");?>" src="../img/misc/inspire_eu_klein.png"></img>
	</p>
</fieldset>
