/**
 * Package: mb_resultList_transferToDigitize
 *
 * Description:
 * <A description>
 * 
 * Files:
 *  - <path and filename, like http/javascripts/mod_zoomIn1.php>
 *
 * SQL:
 * > <SQL for element> 
 * > 
 * > <SQL for element var> 
 *
 * Help:
 * http://www.mapbender.org/<wiki site name>
 *
 * Maintainer:
 * http://www.mapbender.org/User:<user>
 * 
 * Parameters:
 * <normal element var name>      - <type and description>
 * <optional element var name>    - *[optional]* <type and description>
 * <deprecated element var name>  - *[deprecated]* <type and description>
 *
 * License:
 * Copyright (c) 2009, Open Source Geospatial Foundation
 * This program is dual licensed under the GNU General Public License 
 * and Simplified BSD license.  
 * http://svn.osgeo.org/mapbender/trunk/mapbender/license/license.txt
 */

var originalI18nObject = {
	labelButton: "edit"	
};

var translatedI18nObject = cloneObject(originalI18nObject);

Mapbender.events.localize.register(function () {
	Mapbender.modules.i18n.queue(options.id, originalI18nObj, function (translatedObj) {
		if (typeof translatedObj !== "object") {
			return;
		}
		translatedI18nObj = translatedObj;
	});
});

Mapbender.events.init.register(function () {
	var editButton = Mapbender.modules[options.target[0]].addGlobalButton({
		title: translatedI18nObject.labelButton, 
		classes: 'buttonMargin',
		callback: function (data) {
			tab_open(options.digitizeId);


			var digitizeArray = new GeometryArray();

			var wfsConf = get_complete_wfs_conf();
			
			var getJsWfsConfIdByDbWfsConfId = function (wfsConf, id) {
				for (var i = 0; i < wfsConf.length; i++) {
					if (parseInt(wfsConf[i].wfs_conf_id, 10) === id) {
						return i;
					}
				}
				return null;
			};
			
			for (var i in data.selectedRows) {
				digitizeArray.importGeoJSON(data.selectedRows[i].toString());
				digitizeArray.get(-1).wfs_conf = 
					getJsWfsConfIdByDbWfsConfId(wfsConf, parseInt(data.WFSConf.wfs_conf_id));
			}
			window.frames[options.digitizeId].appendGeometryArray(digitizeArray);
			tab_open(options.digitizeId);
		}
	});	
	Mapbender.modules[options.target[0]].events.wfsConfSet.register(function (obj) {
		var isTransactionalGeom = obj.wfsConf.wfs_transaction != "" && obj.wfsConf.wfs_transaction !== null;
		if (!isTransactionalGeom) {
			editButton.hide();
		}
		else {
			editButton.show();			
		}
	});
});
