<?php
require_once 'PHPUnit/Framework.php';
require_once dirname(__FILE__) . "/../../../http/classes/class_group.php";

class GroupTest extends PHPUnit_Framework_TestCase
{
    var $someGroup_name = "demo";
    var $someGroup_description = "Demo Group zum Test";

	public function testCreate()
    {
      $group = new Group(null);
      $group->name = $this->someGroup_name;
      $group->description = $this->someGroup_description;

 
      $this->assertNotNull($group);

      try{
        $create_result = $group->create();
      }
      catch(Exception $E)
      {
        $this->assertEquals($E->getMessage(), 'Could not insert new group');
      }
      $this->assertNotNull($create_result);


      $change_result = $group->change(null);
      $this->assertTrue($change_result);


      try{
        $commit_result =  $group->commit();
      }
      catch(Exception $E)
      {
        $this->assertEquals($E->getMessage(), 'Database error updating Group');
      }
      
      $this->assertTrue($commit_result);
    }

    /*
    * @depends testCreate
    */
    public function testDelete()
    {
      $group = Group::byName($this->someGroup_name);
      $this->assertNotNull($group);

      $remove_result = $group->remove();
      $this->assertTrue($remove_result);

      $group = null;
      $group = Group::byName($this->someGroup_name);
      $this->assertNull($group);
    } 

}
?>
