<?php
require_once 'PHPUnit/Framework.php';
require_once dirname(__FILE__) . '/../../../http/classes/class_user.php';

class UserTest extends PHPUnit_Framework_TestCase
{
    var $someUser_name = "demo";
    var $someUser_description = "Demo User zum Testen";

    public function testCreate()
    {
      $user = new User(null);
      $user->name = $this->someUser_name;
      $user->description = $this->someUser_description;
      $user->public = 1;


      $this->assertNotNull($user);

      try{
        $create_result = $user->create();
      }
      catch(Exception $E)
      {
        $this->assertEquals($E->getMessage(), 'Could not set initial values of new User');
      }
      $this->assertNotNull($create_result);


      $change_result = $user->change(null);
      $this->assertTrue($change_result);
 
      try{
        $commit_result =  $user->commit();
      }
      catch(Exception $E)
      {
        $this->assertEquals($E->getMessage(), 'Database error updating User');
      }
      
      $this->assertTrue($commit_result);

    }

    /*
    * @depends testCreate
    */
    public function testDelete()
    {
      $user = User::byName($this->someUser_name);
      $this->assertNotNull($user);

      $remove_result = $user->remove();
      $this->assertTrue($remove_result);

      $user = null;
      $user = User::byName($this->someUser_name);
      $this->assertNull($user);
    }
}
?>
